<?php
/*
Plugin Name: Form Lightbox
Plugin URI: http://www.myphpmaster.com/form-lightbox
Description: A lightbox for the form.
Version: 1.0
Author: myPHPmaster
Author URI: http://www.myphpmaster.com
License: GPL2
*/

function fl_script() {
	wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'fancybox', plugins_url('/fancybox/jquery.fancybox.js', __FILE__), array('jquery'), '1.3.4' );
	wp_enqueue_style( 'fancybox', plugins_url('/fancybox/fancybox.css', __FILE__) );
}
add_action( 'wp_enqueue_scripts', 'fl_script' );

function fl_text_editor_button($context){
    $image_btn = plugins_url("/form-lightbox.gif", __FILE__);
    $out = '<a href="#TB_inline?width=450&inlineId=fl_form" class="thickbox" title="' . __("Add Form Lightbox", 'form-lightbox') . '"><img src="'.$image_btn.'" alt="' . __("Add Form Lighbox", 'form-lightbox') . '" /></a>';
    return $context . $out;
}
add_action( 'media_buttons_context', 'fl_text_editor_button' );

function fl_shortcode( $atts, $content=null, $code="" ) {
	global $fl_id, $post;

	extract( shortcode_atts( array(
		'text' => 'Click here',
		'style' => 'padding: 10px; width:350px',
		'title' => 'lightbox form',
	), $atts ) );
	
	$fl_id += 1;
	$title = ( $title !== '' ) ?  ' title="' . $title . '"' : '';

	$output = '<a href="#" id="fl_box-' . $fl_id . '"' . $title . '>' . do_shortcode($text) . '</a>';
	$hidden_output = '<div style="display:none"><div id="form-lightbox-' . $fl_id . '" style="' . $style . '">' . do_shortcode($content) . '</div></div>';
	$hidden_output .= '<script type="text/javascript">
		jQuery(document).ready(function() {
			jQuery("#fl_box-' . $fl_id . '").fancybox({
				"type" :"inline", 
				"href" :"#form-lightbox-' . $fl_id . '"
			});
		});
	</script>';

	$post_content = $post->post_content . $hidden_output;

	return $output . $hidden_output;
}
add_shortcode( 'formlightbox', 'fl_shortcode' );

// Check current page url
$current_page = basename($_SERVER['PHP_SELF']);
 
if( in_array( $current_page, array( 'post.php', 'page.php', 'page-new.php', 'post-new.php' ) ) ){
    add_action( 'admin_head',  'add_fl_style' );
    add_action( 'admin_footer',  'add_fl_popup' );
}

function add_fl_style(){
?>
<style type="text/css">
	#form-lightbox td.first {width: 100px;vertical-align: top;}
	#form-lightbox input[type="text"], #form-lightbox textarea {width: 350px;margin-bottom:3px}
	#form-lightbox small {margin-bottom:8px}
</style>
<?php
}
 
function add_fl_popup(){
?>
<script type="text/javascript">
function InsertLightboxForm(){

	var fl_form_text = jQuery("#fl_form_text").val();
	var fl_form_title = jQuery("#fl_form_title").val();
	var fl_form_code = jQuery("#fl_form_code").val();
	var fl_form_style = jQuery("#fl_form_style").val();

	var win = window.dialogArguments || opener || parent || top;
	win.send_to_editor('[formlightbox text="' + fl_form_text + '" title="' + fl_form_title + '" style="' + fl_form_style + '"]' + fl_form_code + '[/formlightbox]');
}
</script> 
<div id="fl_form" style="display:none;">
	<div id="form-lightbox">
    	<div style="padding:10px 0">
			<h3><?php _e("Insert Lightbox Form", "form-lightbox"); ?></h3>
			<span><?php _e("", "form-lightbox"); ?></span>
		</div><br>
		<div style="padding:10px 0;">
			<table><tr>
				<td class="first"><label for="fl_form_text"><?php _e("Link Text", "form-lightbox") ?></label></td>
        			<td><input type="text" value="Click here" id="fl_form_text" name="fl_form_text" /><br />
				<small>This is the link text which will be appeared on the page.</small>
				</td>
			</tr><tr>
				<td class="first"><label for="fl_form_title"><?php _e("Link title", "form-lightbox") ?></label></td>
        			<td><input type="text" value="lightbox form" id="fl_form_title" name="fl_form_title" /><br />
				<small>This will be appeared when lightbox opened</small>
				</td>
			</tr><tr>
				<td class="first"><label for="fl_form_code"><?php _e("Form Code", "form-lightbox") ?></label></td>
        			<td><textarea id="fl_form_code" name="fl_form_code" rows="5" cols="20"></textarea><br />
				<small>Enter shortcode like [contact-form-7 id="848" title="Contact form 1"] or html code</small>
				</td>
			</tr><tr>
				<td class="first"><label for="fl_form_style"><?php _e("Form Style", "form-lightbox") ?></label></td>
        			<td><input type="text" value="padding: 10px; width:350px" id="fl_form_style" name="fl_form_style" /><br />
				<small>This which will be applied to div layer contained the form lightbox.</small>
				</td>
			</tr></table>
		</div>
                <div style="padding:15px;">
                        <input type="button" class="button-primary" value="<?php _e("Insert Lightbox Form", "form-lightbox"); ?>" onclick="InsertLightboxForm();"/>&nbsp;&nbsp;&nbsp;
                    <a class="button" style="color:#bbb;" href="#" onclick="tb_remove(); return false;"><?php _e("Cancel", "form-lightbox"); ?></a>
                </div>
	</div>
</div>
<?php
}